%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

%define cvs 20070725
%define fvwmver 2.5.20

Name:           metisse
Version:        0.4.0
Release:        0.3.%{cvs}cvs%{?dist}
Summary:        Metisse a 3D X Desktop

Group:          User Interface/Desktops
License:        GPL
URL:            http://insitu.lri.fr/metisse
#Source0:        http://insitu.lri.fr/metisse/download/0.4.0-rc4/metisse-%{version}-rc4.tar.bz2
Source0:        http://kwizart.free.fr/fedora/SOURCES/metisse-%{version}-%{cvs}.tar.bz2
Source2:        http://kwizart.free.fr/fedora/SOURCES/metisse-session
Source10:       metisse-snapshot.sh
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

#BuildRequires:  libtool, autoconf, automake
BuildRequires:	desktop-file-utils

BuildRequires:  at-spi-devel
BuildRequires:  avahi-compat-libdns_sd-devel
BuildRequires:  freetype-devel
BuildRequires:  fribidi-devel
BuildRequires:  fontconfig-devel
BuildRequires:  gdbm-devel
BuildRequires:  glibc-headers
BuildRequires:  gnome-libs-devel
BuildRequires:  gtk2-devel
BuildRequires:  libexif-devel
BuildRequires:  libGLU-devel
BuildRequires:  libpng-devel
BuildRequires:  libstroke-devel
BuildRequires:  libXft-devel
BuildRequires:  libXinerama-devel
BuildRequires:  libXpm-devel
BuildRequires:  libXrender-devel
BuildRequires:  libXt-devel
BuildRequires:  libXtst-devel
BuildRequires:  mesa-libGL-devel
BuildRequires:  mesa-libGLU-devel
BuildRequires:  nucleo-devel
BuildRequires:  python-devel
BuildRequires:  readline-devel
BuildRequires:  perl(ExtUtils::MakeMaker)

Requires:  perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
Requires:  perl-Gtk2

Conflicts: fvwm

Requires(post): /sbin/ldconfig
Requires(postun): /sbin/ldconfig


%description
Metisse is an experimental X desktop with some OpenGL capacity.  It
consists of a virtual X server called Xmetisse, a special version of FVWM,
and a FVWM module FvwmCompositor. Xmetisse is a mix of Xvnc and XDarwin. It
draws nothing on your screen; everything is drawn into
pixmaps. Similarly to Xvnc, but with a different protocol, Xmetisse can
send these pixmaps (and other information) to a "viewer". FvwmCompositor
is such a viewer; it uses OpenGL for rendering the X desktop into a
window of a "regular" 3D accelerated X server.

%package        devel
Summary:        Dynamic development library for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       pkgconfig

%description    devel
Dynamic development library for %{name}.


%prep
%setup -q
# Filter out false Perl provides
cat << \EOF > %{name}-prov
#!/bin/sh
%{__perl_provides} $* |\
  sed -e '/perl(FVWM::.*)\|perl(FvwmCommand)\|perl(General::FileSystem)\|perl(General::Parse)/d'
EOF

%define __perl_provides %{_builddir}/%{name}-%{version}/%{name}-prov
chmod +x %{__perl_provides}


# Filter false requires for old perl(Gtk) and for the above provides
cat << \EOF > %{name}-req
#!/bin/sh
%{__perl_requires} $* |\
  sed -e '/perl(Gtk)\|perl(FVWM::Module::Gtk)\|perl(FVWM::.*)\|perl(FvwmCommand)\|perl(General::FileSystem)\|perl(General::Parse)/d'
EOF

%define __perl_requires %{_builddir}/%{name}-%{version}/%{name}-req
chmod +x %{__perl_requires}



%build
export CFLAGS="$RPM_OPT_FLAGS -I%{_includedir}/gdbm"
export CPPFLAGS="$RPM_OPT_FLAGS -I%{_includedir}/gdbm"
export CXXFLAGS="$RPM_OPT_FLAGS -I%{_includedir}/gdbm"
%configure \
  --with-release-snap="%{cvs}" \
  --with-vendor-web="http://fedoraproject.org/" \
  --with-os-name="Fedora 7" \
  --with-os-vendor="Redhat, inc" \
  --with-fontdir=%{_datadir}/X11/fonts \
  --with-fontenc-file=%{_datadir}/X11/fonts/encodings/encodings.dir \
  --x-includes=%{_includedir} \
  --x-libraries=%{_libdir} \
  --disable-static \
%ifarch %{ix86}
  --enable-glx-x86 \
%endif
    --enable-glx \
%ifarch %{ix86} x86_64
    --enable-mmx \
%endif
    --with-x

make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'

rm -rf $RPM_BUILD_ROOT/etc

cat > %{name}.desktop  <<EOF
[Desktop Entry]
Encoding=UTF-8
Name=Metisse
Comment=This session logs you into METISSE
Exec=metisse-session
Icon=
Categories=Settings;X-Fedora;
Type=Application
EOF

cat > fvwmi.desktop  <<EOF
[Desktop Entry]
Encoding=UTF-8
Name=FVWMI
Comment=FVWM InSitu
Exec=fvwmi
Icon=opale.png
Type=Application
Version=1.0
Categories=Settings;X-Fedora;
EOF

cat > mini-fvwmi.desktop  <<EOF
[Desktop Entry]
Encoding=UTF-8
Name=Mini-FVWMI
Comment=FVWM InSitu With minimal config
Exec=opale-start-fvwmi -o mini
Icon=
Type=Application
Categories=Settings;X-Fedora;
Version=1.0
EOF

cat > opale.desktop  <<EOF
[Desktop Entry]
Encoding=UTF-8
Name=Opale
Comment=Opale - FVWM InSitu
Exec=opale-start-fvwmi
Icon=opale.png
Type=Application
Categories=Settings;X-Fedora;
Version=1.0
EOF

desktop-file-install --vendor livna			\
    --dir $RPM_BUILD_ROOT%{_datadir}/applications	\
    --mode 644						\
    %{name}.desktop

desktop-file-install --vendor livna			\
    --dir $RPM_BUILD_ROOT%{_datadir}/applications	\
    --mode 644						\
    fvwmi.desktop

desktop-file-install --vendor livna			\
    --dir $RPM_BUILD_ROOT%{_datadir}/applications	\
    --mode 644						\
    mini-fvwmi.desktop

desktop-file-install --vendor livna			\
    --dir $RPM_BUILD_ROOT%{_datadir}/applications	\
    --mode 644						\
    opale.desktop


chmod 0755 $RPM_BUILD_ROOT%{_datadir}/metisse/fvwm/scripting.pl
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/fvwm-insitu/common
mkdir -p $RPM_BUILD_ROOT%{_datadir}/fvwm-insitu/tr-images
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/X11/wmsession.d
mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps
install -m 0644 fvwm-insitu/opale/icons/16x16/apps/opale.png $RPM_BUILD_ROOT%{_datadir}/pixmaps
#ln -s ../fvwm-insitu/opale/icons/16x16/apps/opale.png $RPM_BUILD_ROOT%{_datadir}/pixmaps/opale.png
ln -s fvwmi-config $RPM_BUILD_ROOT%{_bindir}/fvwm-config

install -pm 0755 %{SOURCE2} $RPM_BUILD_ROOT%{_bindir}/metisse-session

# Fix rpmlint error
chmod +x $RPM_BUILD_ROOT%{_datadir}/metisse/fvwm/scripting.pl

# Fedora doesn't have old Gtk Perl
rm $RPM_BUILD_ROOT%{_datadir}/fvwm-insitu/perllib/FVWM/Module/Gtk.pm
rm $RPM_BUILD_ROOT%{_libexecdir}/fvwm-insitu/%{fvwmver}/FvwmGtkDebug

%find_lang FvwmTaskBar 
%find_lang FvwmScript 
%find_lang fvwm
cat FvwmTaskBar.lang |grep lang >> fvwm.lang
cat FvwmScript.lang |grep lang >> fvwm.lang

%post
%{_bindir}/update-desktop-database %{_datadir}/applications > /dev/null 2>&1
/sbin/ldconfig || :


%postun
%{_bindir}/update-desktop-database %{_datadir}/applications > /dev/null 2>&1
/sbin/ldconfig || :

%clean
rm -rf $RPM_BUILD_ROOT


%files -f fvwm.lang
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog COPYING NEWS README TODO
%exclude %{_bindir}/*-config
%{_bindir}/*
%{_libdir}/*.so.*
%{_datadir}/%{name}/
%{_datadir}/applications/*.desktop
%{_datadir}/pixmaps/opale.png
%{_libexecdir}/fvwm-insitu
%{_datadir}/fvwm-insitu
%dir %{_sysconfdir}/X11/wmsession.d
%{_mandir}/man1/*.1.gz
%{python_sitelib}/*.py
%exclude %{python_sitelib}/*.py?

%files devel
%defattr(-,root,root,-)
%{_includedir}/libmetisse/
%{_bindir}/*-config
%{_libdir}/pkgconfig/*.pc
%{_libdir}/*.so

%changelog
* Wed Jul 25 2007 kwizart < kwizart at gmail.com > - 0.4.0-0.3.20070725cvs
- Update to 20070725cvs

* Mon Feb 05 2007 kwizart < kwizart at gmail.com > - 0.4.0-0.2.rc4
- Fix 64bit compilation.
- Merge spec from Christopher Stone

* Thu Jan 25 2007 kwizart < kwizart at gmail.com > - 0.4.0-0.1.rc4
- Initial Release 

* Wed Jun 14 2006 Christopher Stone <chris.stone@gmail.com> 0.4.0-2
- Remove makeinstall macro
- Fix up libtool usage
- Fix resolution setting in metisse-session file
- Remove pkgconfig from BuildRequires

* Mon Jun 05 2006 Christopher Stone <chris.stone@gmail.com> 0.4.0-1
- Initial release
